/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

(function(window) {

const TABLES = [
    { "name": "BUCHUNG", "primary": ["wochentag", "stunde", "raum"], "table": [
        ["wochentag", "stunde", "lehrkraft", "fach", "raum"],
        ["Mo", 2, "Picasso", "Kunst", "D01"],
        ["Di", 7, "Roith", "Wahlkurs 3D-Druck", "D03"],
        ["Do", 3, "Picasso", "Kunst", "D01"],
        ["Di", 3, "Picasso", "Kunst", "D03"],
        ["Mo", 1, "Curie", "Chemie", "D03"],
        ["Mo", 2, "Curie", "Physik", "D03"],
        ["Mo", 6, "Christie", "Englisch", "D01"],
        ["Di", 5, "Christie", "Englisch", "D01"],
        ["Do", 7, "Goethe", "Deutsch", "D01"],
        ["Mo", 3, "Christie", "Englisch", "D01"],
        ["Di", 3, "Orwell", "Englisch", "D01"]
    ] }
];

const LEVELS = [
    {
        "task": "<p>An einer Schule gibt es einige Spezialräume, die Lehrkräfte für ihren Unterricht buchen können. Diese Buchungen sind alle in der Datenbanktabelle <code>BUCHUNG</code> gespeichert.</p><p>Nur, damit du den Inhalt der Datenbanktabelle besser verstehst: Schreibe eine Abfrage, die dir die komplette Datenbanktabelle (mit allen Attributen in der Originalreihenfolge) liefert. Führe diese Abfrage aus, schaue dir die Datenbanktabelle genau an und beantworte dann einige Fragen dazu.</p>",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
        ],
        "checkTermination": [
            { "type": "sameResult", "value": "SELECT * FROM BUCHUNG", "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht bestmöglich der Datenbanktabelle…" },
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Kreuze nur wahre Aussagen an und ergänze die Lücken richtig:",
            "choices": [
                { "html": "Der Raum <em>D01</em> ist am Freitag in der sechsten Stunde von der Lehrkraft namens ", "type": "text", "unit": " gebucht.", "response": "Da es keinen Datenstatz mit <code>wochentag = \"Fr\"</code>, <code>stunde = 6</code> und <code>raum = \"D01\"</code> gibt, ist der Raum D01 nicht am Freitag in der sechsten Stunde gebucht." },
                { "html": "Der Raum <em>D03</em> ist am Dienstag in der dritten Stunde von der Lehrkraft namens ", "type": "text", "accept": "Picasso", "unit": " gebucht.", "response": "Der vierte Datensatz zeigt, dass Picasso den Raum D03 dienstags in der dritten Stunde gebucht hat.", "correct": true },
                { "html": "Der Raum <em>D01</em> ist am Dienstag in der siebten Stunde von der Lehrkraft namens ", "type": "text", "unit": " gebucht.", "response": "Da es keinen Datenstatz mit zugleich <code>wochentag = \"Di\"</code>, <code>stunde = 7</code> und <code>raum = \"D01\"</code> (auf Raumnummer achten!) gibt, ist der Raum D01 nicht am Dienstag in der siebten Stunde gebucht." },
                { "html": "Beispielsweise die Lehrkraft namens ", "type": "text", "accept": ["Christie", "Picasso", "Curie"], "unit": " hat denselben Raum mehrfach gebucht.", "correct": true }
            ]
        }
    },
    {
        "task": "Die Auswertung der Daten kann doch sicher auch eine Abfrage für uns erledigen. Probieren wir es gleich aus: Schreibe eine Abfrage, die eine Liste aller Raumnummern der gebuchten Spezialräume als Ergebnistabelle liefert.",
        "keepCode": true,
        "code": "SELECT * FROM BUCHUNG",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" },
            { "type": "keyword", "value": "distinct", "max": 0, "fine": 0, "msg": "Das Schlüsselwort „DISTINCT“ lernst du erst im nächsten Level kennen. Jetzt also noch nicht verwenden!" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 1, "fine": 1, "msg": "Die Ergebnistabelle soll nur das fragliche Attribut enthalten" },
            { "type": "attributeName", "index": 0, "value": "raum", "fine": 1, "msg": "Das einzige Attribut muss „raum“ sein" },
            { "type": "sameResult", "value": "SELECT raum FROM BUCHUNG", "fine": 1 },
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Was ist an dieser Liste nicht wirklich ideal?",
            "singlechoice": true,
            "choices": [
                { "html": "Dieselbe Raumnummer kommt mehrfach vor", "correct": true },
                { "html": "Die Ergebnistabelle enthält unnötige Attribute" },
                { "html": "Die Ergebnistabelle enthält auch Räume, die zwar gebucht werden könnten, nicht aber gebucht wurden" },
                { "html": "Man kann nicht sicher sein, dass es zu jedem aufgelisteten Raum auch einen Datensatz gibt" }
            ]
        }
    },
    {
        "task": "Schaue dir nun diese SQL-Abfrage an (zunächst ohne sie auszuprobieren!) und beantworte die Frage.",
        "code": "SELECT DISTINCT raum FROM BUCHUNG",
        "readonly": true,
        "tables": TABLES,
        "locked": false,
        "checkCode": [
            { "type": "accept", "accept": false, "fine": 1, "msg": "Du sollst die Abfrage noch nicht ausprobieren!" }
        ],
        "checkTermination": [],
        "questionWrongFine": 1,
        "question": {
            "html": "Worin unterscheidet sich diese Abfrage von bisherigen SQL-Abfragen?",
            "choices": [
                { "html": "Sie enthält ein neues Schlüsselwort, nämlich ", "type": "text", "casesensitive": false, "accept": "DISTINCT", "correct": true },
                { "html": "Die Art, wie die Tabelle angegeben wird, ist anders" },
                { "html": "Eine zusätzliches, nicht im Tabellenschema enthaltenes Attribut wird angegeben, nämlich ", "type": "text", "response": "„DISTINCT“ kann kein Attributname sein, denn dann müsste zwischen „DISTINCT“ und „raum“ ein Komma stehen. Außerdem verrät dieselbe Formatierung wie bei „SELECT“, dass es sich um ein Schlüsselwort handelt." }
            ]
        }
    },
    {
        "task": "Probiere nun diese neue SQL-Abfrage aus.",
        "code": "SELECT DISTINCT raum FROM BUCHUNG",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
        ],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Was bewirkt offenbar das Schlüsselwort <code>DISTINCT</code> bezüglich der Ergebnistabelle?",
            "choices": [
                { "html": "Kein gleicher Datensatz der Ergebnistabelle kommt noch mehrfach vor", "correct": true },
                { "html": "Kein Attribut kommt noch mehrfach vor" },
                { "html": "Jeder Datensatz kommt nun mehrfach vor" },
                { "html": "Jedes Attribut kommt nun mehrfach vor" }
            ]
        }
    },
    {
        "task": "<p>Das Schlüsselwort <code>DISTINCT</code> direkt nach <code>SELECT</code> bewirkt also, dass doppelte Datensätze aus der Ergebnistabelle gelöscht werden, sodass nicht Dasselbe mehrfach vorkommt.</p><p>Ändere die Abfrage so ab, dass sie eine Liste aller Lehrkräfte liefert, die irgendeinen Spezialraum gebucht haben. Aber jede fragliche Lehrkraft soll nur einmal aufgelistet werden.</p>",
        "keepCode": true,
        "code": "SELECT DISTINCT raum FROM BUCHUNG",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" },
            { "type": "keyword", "value": "distinct", "min": 1, "fine": 1, "msg": "Verwende das neu gelernte Schlüsselwort „DISTINCT“, damit jede Lehrkraft höchstens einmal in der Ergebnistabelle auftaucht!" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 1, "fine": 1, "msg": "Die Ergebnistabelle soll nur das fragliche Attribut enthalten" },
            { "type": "attributeName", "index": 0, "value": "lehrkraft", "fine": 1, "msg": "Das einzige Attribut muss „lehrkraft“ sein" },
            { "type": "sameResult", "value": "SELECT DISTINCT lehrkraft FROM BUCHUNG", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Diese Abfrage liefert eine Liste aller Wochentage, für die es eine Spezialraumbuchung gibt. Unnötigerweise werden aber einige Wochentage mehrfach aufgeführt. Ändere das! Du kannst auch zunächst die Abfrage unverändert ausführen, aber nur die berichtigte Abfrage (in der jeder Wochentag mit Spezialraumbuchung nur einmal vorkommt) schaltet das nächste Level frei.",
        "keepCode": true,
        "code": "SELECT wochentag FROM BUCHUNG",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "sameResult", "value": "SELECT DISTINCT wochentag FROM BUCHUNG", "fine": 0, "accept": true, "unlock": true, "inverted": true, "msg": "Prima, jetzt kommt kein Wochentag mehr doppelt vor" },
            { "type": "accept", "msg": "Abfrage ausgeführt (aber Level noch nicht gelöst)" }
        ]
    },
    {
        "task": "Schaue dir nun diese SQL-Abfrage an (zunächst ohne sie auszuprobieren!) und beantworte die Frage.",
        "code": "SELECT DISTINCT fach, raum FROM BUCHUNG",
        "readonly": true,
        "tables": TABLES,
        "locked": false,
        "checkCode": [
            { "type": "accept", "accept": false, "fine": 1, "msg": "Du sollst die Abfrage noch nicht ausprobieren!" }
        ],
        "checkTermination": [],
        "questionWrongFine": 1,
        "question": {
            "html": "Welche der Aussagen ist für die obige SQL-Abfrage wohl richtig?",
            "singlechoice": true,
            "response": "Beachte: <code>DISTINCT</code> löscht identische Kopien von Datensätzen, nicht von einzelnen Attributwerten.",
            "choices": [
                { "html": "Jede <em>Kombination</em> aus Fach und Raumnummer kann nur einmal in der Ergebnistabelle auftauchen", "correct": true },
                { "html": "Jede <em>Fach</em> kann höchstens einmal in der Ergebnistabelle stehen" },
                { "html": "Jede <em>Raumnummer</em> kann höchstens einmal in der Ergebnistabelle stehen" },
                { "html": "Jede <em>Raumnummer</em> und jedes <em>Fach</em> kann jeweils höchstens einmal in der Ergebnistabelle stehen" }
            ]
        }
    },
    {
        "task": "Überzeuge dich nun davon, dass einzelne Attributwerte bei dieser Abfrage durchaus mehrfach in der Ergebnistabelle stehen können. Nur die Kombination beider Attributwerte ist für jeden Datensatz der Ergebnistabelle einmalig.",
        "code": "SELECT DISTINCT fach, raum FROM BUCHUNG",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Verstanden? Dann schreibe und teste jetzt eine Abfrage, die eine Liste liefert, für welches Fach welche Lehrkraft (in dieser Reihenfolge!) einen Spezialraum gebucht hat. Dasselbe soll aber nicht mehrfach in der Liste stehen.",
        "keepCode": false,
        "code": "",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "where", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 2, "fine": 1, "msg": "Die Ergebnistabelle soll nur die geforderten beiden Attribute enthalten" },
            { "type": "attributeName", "index": 0, "value": "fach", "fine": 1, "msg": "Das erste Attribut muss „fach“ sein" },
            { "type": "attributeName", "index": 1, "value": "lehrkraft", "fine": 1, "msg": "Das zweite Attribut muss „lehrkraft“ sein" },
            { "type": "keyword", "value": "distinct", "min": 1, "fine": 1, "msg": "Verwende das neu gelernte Schlüsselwort „DISTINCT“, damit jeder Eintrag höchstens einmal in der Ergebnistabelle auftaucht!" },
            { "type": "sameResult", "value": "SELECT DISTINCT fach, lehrkraft FROM BUCHUNG", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Diese Abfrage kannst du gerne ausprobieren oder auch nicht. Aber beantworte die Frage unten!",
        "keepCode": false,
        "code": "SELECT DISTINCT * FROM BUCHUNG",
        "tables": TABLES,
        "readonly": true,
        "locked": false,
        "checkCode": [],
        "checkTermination": [],
        "questionWrongFine": 1,
        "question": {
            "html": "Wieso macht <code>DISTINCT</code> in dieser Abfrage keinen Unterschied?",
            "singlechoice": true,
            "choices": [
                { "html": "Weil sich die Datensätze mindestens in den Primärschlüsselwerten unterscheiden müssen, kann es keine doppelten Datensätze geben", "correct": true },
                { "html": "Weil das Sternchen ohnehin bedeutet, dass beliebige Datensätze zufällig ausgewählt werden sollen" },
                { "html": "Weil das Sternchen „alles auswählen“ bedeutet und das offenbar Vorrang vor <code>DISTINCT</code> hat" },
                { "html": "Weil es in der Datenbanktabelle <code>BUCHUNG</code> zufälligerweise keinen doppelten Datensatz gibt" }
            ]
        }
    }
];

window.sqlCodingTask = {
    levels: LEVELS
};
})(window);
